*---------------------------------------------------------------------------------------*
* g_circle : ~ʕ`									*
*		98-05-17 Ver 1.0							*
*											*
*	 : int (x,y)  ~̒SW						*
*	       int r      ~̔a							*
*	       int b/a    Ε							*
*	       int col    J[io[						*
*											*
*	߂l : d0 =   0  I							*
*		      -50  p[^[G[					*
*		      -40  uq`l̎gp֎~					*
*											*
*	NOTE : V{'eor'̒`ŔrI_a					*
*---------------------------------------------------------------------------------------*

		.include	iocscall.mac
		.include	errnum.h

.ifdef eor
		.xdef		_eor_circle
		.xdef		eor_circle_main
.else
		.xdef		_g_circle
		.xdef		g_circle_main
.endif
		.xref		g_xyadr
		.xref		g_check
		.xref		g_mode

PSET		.macro		col,adr
.ifdef eor
		eor.w		col,adr
.else
		move.w		col,adr
.endif
.endm

* ߂(16iŏ_Qʂ܂)
* INPUT val (0-32767)
* Use Resist d0-d2
* OUTPUT d0.w ($nn.nn)

SQR		.macro		val
		.local		plus
		.local		done
		swap.w		val		* val = val * (256)^2
		move.w		#$FFFF,d0	* d0 = 65535
		move.w		d0,d2		* d2 : Zp
@@:		move.w		d0,d1
		mulu.w		d1,d1		* d1 = d0 ^ 2
		lsr.w		#1,d2		* d2 = d2 / 2
		beq		done		* d2OȂI
		cmp.l		val,d1		* d0d1vI
		beq		done
		bcs		plus		* d0 > d1  goto plus
		sub.w		d2,d0
		bra		@B
plus:		add.w		d2,d0
		bra		@B
done:		* lsr.w		#4,d0		* val = val / 16
.endm

* ő񐔂߂
* INPUT M,N (0-32767)
* Use Resist d0
* OUTPUT d0.w

GCM		.macro		M,N
		move.w		N,d0
@@:		moveq.l		#0,N
		move.w		d0,N
		divu.w		M,N
		move.w		M,d0
		swap.w		N
		move.w		N,M
		bne		@B
.endm

		.offset		8		* _g_circle()p

_X:		ds.l		1
_Y:		ds.l		1
_R:		ds.l		1
_A:		ds.l		1
_B:		ds.l		1
_COL:		ds.l		1

		.offset		8		* g_circle_mainp

GX:		ds.w		1
GY:		ds.w		1
GR:		ds.w		1
GA:		ds.w		1
GB:		ds.w		1
GCOL:		ds.w		1

		.offset		-2*5-4*4

PADR:
CX:		ds.w		1
CY:		ds.w		1
A:		ds.w		1
B:		ds.w		1
COL:		ds.w		1
MINX:		ds.l		1		* NbsOp
MINY:		ds.l		1
MAXX:		ds.l		1
MAXY:		ds.l		1

iocs		equ		$0f

		.text
		.even

_g_circle:
_eor_circle:
		bsr		g_check
		tst.l		d0
		beq		@F

		rts
@@:
		link		a6,#PADR
		movem.l		d1-d7/a0-a5,-(sp)

		subq.l		#8,sp
		bsr		g_mode
		movem.l		(sp)+,d0/a0		* a0 : line width (512 or 1024)

		movem.l		_X(a6),d1-d6		* (d1,d2) = (CX,CY) d3 = R
		cmp.l		d0,d6			* d4/d5 = A/B
		bcc		par_error		* d6 = COLOR
		move.l		#32767,d0		* d0 : MAX
		move.l		#-32768,d7		* d7 : MIN
		cmp.l		d7,d1			* MIN < CX ?
		blt		par_error
		cmp.l		d0,d1			* MAX > CX ?
		bgt		par_error
		cmp.l		d7,d2			* MIN < CY ?
		blt		par_error
		cmp.l		d0,d2			* MAX > CY ?
		bgt		par_error
		cmp.l		d0,d3			* MAX > R ?
		bhi		par_error
		cmp.l		d0,d4			* MAX > A ?
		bhi		par_error
		cmp.l		d0,d5			* MAX > B ?
		bhi		par_error

		bra		ent

g_circle_main:
eor_circle_main:
		bsr		g_check
		tst.l		d0
		beq		@F

		rts
@@:
		link		a6,#PADR
		movem.l		d1-d7/a0-a5,-(sp)

		subq.l		#8,sp
		bsr		g_mode
		movem.l		(sp)+,d0/a0		* a0 : line width (512 or 1024)
		subq.l		#1,d0

		movem.w		GX(a6),d1-d6		* (d1,d2) = (CX,CY) d3 = R
							* d4/d5 = A/B
		cmp.w		d0,d6			* d6 = COLOR
		bhi		par_error
		tst.w		d3
		bmi		par_error
		beq		done			* R=0 Ȃ done 
		tst.w		d4
		ble		par_error
		tst.w		d5
		ble		par_error

ent:
*		A/B񕪂
*		move.w		d6,-(sp)
*		move.w		d4,d6
*		move.w		d5,d7
*		GCM		d6,d7
*		divu.w		d0,d4
*		divu.w		d0,d5
*		move.w		(sp)+,d6

		movem.w		d1-d2/d4-d6,CX(a6)

		moveq.l		#0,d6
		move.w		d4,d6			* d6 = d4 = A
		SQR		d6			* d0 = A^(1/2) * 256
		move.l		d3,d1
		lsl.l		#8,d1
		divu.w		d0,d1			* d1 = X0 = R / (A^(1/2))

		mulu.w		d0,d3
		lsr.l		#7,d3			* d3 = 2*R*(A^(1/2))
		moveq.l		#0,d2
		move.w		d4,d2
		add.l		d5,d2			* d2 = A + B
		add.l		d2,d4			* d4 = 2*A + B
		add.l		d2,d5			* d5 = A + 2*B
		sub.l		d3,d5			* d5 = F0 = -2*(A^(1/2))*R + A + 2*B
		sub.l		d3,d4
		sub.l		d3,d4			* d4 = H0 = -4*(A^(1/2))*R + 2*A + B
		move.w		A(a6),d2
		add.w		d2,d2			* d2 = 2*A
		swap.w		d2
		move.w		d1,d2			* d2.H = 2*A ; d2.L = X0
		add.l		d3,d3			* d3 = 4*A*X0 = 4*A^(1/2)*R
		moveq.l		#0,d1
		move.w		B(a6),d1
		add.w		d1,d1			* d3 = 2*B
		swap.w		d1			* d3.H = 2*B ; d3.L = Y0

		* GRAM̱ڽ߂
		movem.w		CX(a6),d6-d7		* d6 = CX : d7 = CY
		move.l		a0,d0
		mulu.w		d7,d0
		add.l		d6,d0
		add.l		d0,d0
		movea.l		#$C00000,a2
		adda.l		d0,a2			* a2 = GRAM Address (CX,CY)
		movea.l		a2,a4
		adda.w		d2,a2
		adda.w		d2,a2			* a2 = GRAM Address (CX+X0,CY)
		suba.w		d2,a4
		suba.w		d2,a4			* a4 = GRAM Address (CX-X0,CY)
		movea.l		a2,a3			* a3 = a2
		movea.l		a4,a5			* a5 = a4

		* NbsÖ
		clr.l		MINX(a6)
		sub.l		d6,MINX(a6)
		clr.l		MINY(a6)
		sub.l		d7,MINY(a6)
		subq.w		#1,a0
		move.l		a0,MAXX(a6)
		sub.l		d6,MAXX(a6)
		move.l		a0,MAXY(a6)
		sub.l		d7,MAXY(a6)
		addq.w		#1,a0

		move.w		COL(a6),d6
		moveq.l		#0,d7
		adda.w		a0,a0

		moveq.l		#_B_SUPER,d0
		clr.l		a1
		trap		#iocs
		movea.l		d0,a1			* a1 : USP

*		d2.H = 2*A ; d2.L = X0 ; d1.H = 2*B ; d1.L = Y0(=0)
*		d4.l = H0 ; d5.l = F0 ; d6.w = COLOR
*		d3.l = 4*A*X0 ; d7.l = 4*B*Y0(=0)
*		a0 = Line Width (1024 or 2048) ; a1 = USP
*		a2 = (CX+X,CY+Y) ; a3 = (CX+X,CY-Y)
*		a4 = (CX-X,CY+Y) ; a5 = (CX-X,CY-Y)

main_loop:
		move.w		d2,d0
		ext.l		d0		* d0 = X
		cmp.l		MINX(a6),d0	* MINX > X ?
		blt		main_end
		cmp.l		MAXX(a6),d0	* MAXX < X ?
		bgt		skipR
		move.w		d1,d0
		ext.l		d0		* d0 = Y
		cmp.l		MINY(a6),d0	* MINY > Y ?
		blt		@F
		cmp.l		MAXY(a6),d0	* MAXY < Y ?
		bgt		@F
		PSET		d6,(a2)		* PSET(CX+x,CY+y,col)
@@:		neg.l		d0		* d0 = -Y
		cmp.l		MINY(a6),d0	* MINY > -Y ?
		blt		@F
		cmp.l		MAXY(a6),d0	* MAXY < -Y ?
		bgt		@F
		PSET		d6,(a3)		* PSET(CX+x,CY-y,col)
@@:
		move.w		d2,d0
		ext.l		d0

skipR:
		neg.l		d0		* d0 = -X
		cmp.l		MINX(a6),d0	* MINX > -X ?
		blt		skipL
		cmp.l		MAXX(a6),d0	* MAXX < -X ?
		bgt		main_end
		move.w		d1,d0
		ext.l		d0		* d0 = Y
		cmp.l		MINY(a6),d0	* MINY > Y ?
		blt		@F
		cmp.l		MAXY(a6),d0	* MAXY < Y ?
		bgt		@F
		PSET		d6,(a4)		* PSET(CX-x,CY+y,col)
@@:		neg.l		d0		* d0 = -Y
		cmp.l		MINY(a6),d0	* MINY > -Y ?
		blt		skipL
		cmp.l		MAXY(a6),d0	* MAXY < -Y ?
		bgt		skipL
		PSET		d6,(a5)		* PSET(CX-x,CY-y,col)

skipL:
		tst.l		d5			* if( F<0 ) {
		bge		@F
		addq.w		#1,d1			*	y++;
		moveq.l		#0,d0
		swap.w		d1
		move.w		d1,d0
		swap.w		d1
		add.l		d0,d7
		add.l		d0,d7			* d7 = d7 + 4*B
		adda.w		a0,a2
		suba.w		a0,a3
		adda.w		a0,a4
		suba.w		a0,a5
		add.l		d7,d5
		add.l		d0,d5			*	F += 4*B*y + 2*B;
		add.l		d7,d4			*	H += 4*B*y;
		bra		main_loop
@@:							* } else {
		tst.l		d4			* if( H>0 ) {
		ble		@F
		subq.w		#1,d2			*	x--;
		bmi		main_end
		moveq.l		#0,d0
		swap.w		d2
		move.w		d2,d0			* d0 = 2*A
		swap.w		d2
		sub.l		d0,d3
		sub.l		d0,d3			* d3 = d3 - 4*A
		subq.w		#2,a2
		subq.w		#2,a3
		addq.w		#2,a4
		addq.w		#2,a5
		sub.l		d3,d5			*	F -= 4*A*x;
		sub.l		d3,d4
		add.l		d0,d4			*	H -= 4*A*x - 2*A;
		bra		main_loop
@@:							* } else {
		subq.w		#1,d2			*	x--;
		bmi		main_end
		moveq.l		#0,d0
		swap.w		d2
		move.w		d2,d0			* d0 = 2*A
		swap.w		d2
		sub.l		d0,d3
		sub.l		d0,d3			* d3 = d3 - 4*A
		subq.w		#2,a2
		subq.w		#2,a3
		addq.w		#2,a4
		addq.w		#2,a5
		sub.l		d3,d5			*	F -= 4*A*x;
		sub.l		d3,d4
		add.l		d0,d4			*	H -= 4*A*x - 2*A;

		addq.w		#1,d1			*	y++;
		swap.w		d1
		move.w		d1,d0
		swap.w		d1
		add.l		d0,d7
		add.l		d0,d7			* d7 = d7 + 4*B
		adda.w		a0,a2
		suba.w		a0,a3
		adda.w		a0,a4
		suba.w		a0,a5
		add.l		d7,d5
		add.l		d0,d5			*	F += 4*B*y + 2*B;
		add.l		d7,d4			*	H += 4*B*y;
		bra		main_loop

main_end:
		cmpa.l		#-1,a1
		beq		done
		moveq.l		#_B_SUPER,d0
		trap		#iocs

done:		movem.l		(sp)+,d1-d7/a0-a5
		unlk		a6
		moveq.l		#0,d0

		rts

par_error:
		movem.l		(sp)+,d1-d7/a0-a5
		unlk		a6
		moveq.l		#PAR_ERR,d0

		rts

VRAM_use_error:
		moveq.l		#VRAM_USE_ERR,d0

		rts

		.end